<template>
  <div class="navbar" v-if="currentRoute !== 'join'">
    <v-app-bar
      v-if="!isUserLoggedIn && currentRoute !== 'quiz'"
      flat
      absolute
      color="transparent"
      height="64"
      :class="{ offline: !networkOnLine }"
    >
      <default-nav-bar :app-title="appTitle" />
    </v-app-bar>

    <v-app-bar
      v-if="isUserLoggedIn && user.role === Role.USER"
      flat
      absolute
      color="transparent"
      :class="{ offline: !networkOnLine }"
    >
      <auth-user-nav-bar />
    </v-app-bar>
  </div>
</template>

<script>
import { mapGetters, mapState, mapActions } from 'vuex'
import { Role } from '@/constants'
import AuthUserNavBar from './AuthUserNavBar'
import DefaultNavBar from './DefaultNavBar'

export default {
  components: {
    DefaultNavBar,
    AuthUserNavBar
  },
  computed: {
    ...mapGetters('authentication', ['isUserLoggedIn']),
    ...mapState('authentication', ['user']),
    ...mapState('app', ['networkOnLine', 'appTitle', 'appShortTitle']),
    currentRoute: {
      get() {
        return this.$route.name
      }
    }
  },
  data: () => ({
    Role
  }),
  methods: {
    ...mapActions('authentication', ['logout'])
  },
}
</script>

<style lang="scss" scoped>
@import '@/sass/variables.scss';

.navbar {
  z-index: 1;
  height: 64px;
  a {
    display: flex;
    align-items: center;
  }

  .title-desktop {
    display: inline;
  }

  .title-mobile {
    display: none;
  }

  @media (max-width: 500px) {
    padding: 0.7rem 0.7rem;

    .can-hide {
      display: none;
    }

    .title-desktop {
      display: none;
    }

    .title-mobile {
      display: block;
    }
  }

  .site-name {
    font-size: 1.3rem;
    font-weight: 600;
    color: #2c3e50;
    position: relative;
  }

  .logo {
    height: 24px;
    padding-right: 8px;
  }

  .links {
    padding-left: 1.5rem;
    box-sizing: border-box;
    white-space: nowrap;
    font-size: 0.9rem;
    position: absolute;
    right: 1.5rem;
    top: 0.7rem;
    display: flex;

    .nav-links {
      display: flex;
      align-items: center;
      justify-content: center;

      .nav-item {
        position: relative;
        display: inline-block;
        margin-left: 1.5rem;
        line-height: 2.2rem;

        &:first-child {
          margin-left: 0;
        }

        a {
          font-weight: 500;
          font-size: 0.9rem;
          text-decoration: none;
          color: $navbar-link-color;
          border-color: #2c3e50;
          line-height: 1.4rem;
          display: inline-block;
          cursor: pointer;
        }

        @mixin activatedLink() {
          margin-bottom: -2px;
          border-bottom: 2px solid $vue-color;
        }

        .router-link-active {
          @include activatedLink;
        }

        @media (hover) {
          :hover {
            @include activatedLink;
          }
        }
      }
    }
  }

  &.offline {
    background: $navbar-offline-color;

    .links .nav-links .nav-item a,
    .site-name {
      color: white;
    }
  }

  .user-picture {
    max-height: 32px;
    margin-left: 1.5rem;
    border-radius: 50%;
  }

  .offline-label {
    padding: 0px 10px;
    border: 1px solid white;
    border-radius: 5px;
    color: white;
    margin-left: 1.5rem;
  }
}
</style>
